
///-----------------------------------------------------------------
///
/// @file      MyGraph.h
/// @author    Martin Sarva
/// Created:   25. 2. 2010 13:17:18
/// @section   DESCRIPTION
///            Node class declaration
///
///------------------------------------------------------------------
#include <iostream>
#include <wx/gdicmn.h>
#include <wx/dcbuffer.h>
#include <map>
#include <math.h>
#include "tinyxml.h"
//#include <ext/hash_map>
using namespace std;
//using namespace __gnu_cxx;


struct Pedge
{
    int id;
    bool in;
    Pedge *next;
    Pedge *prev;
    
};

struct Node
{
    int id;
    int x;
    int y;
    int Width;
    int Height;
    Node *LeftBrother;
    Node *RightBrother;
    Node *FirstSon;
    //Node *LastSon;
    Node *Father;
    bool collapsed; 
    Pedge *next;
   // bool back;

};
struct Line{
    float q;
    float k;
};


struct Edge
{
    int id;
    Line *l;
    Node *Source;
    Node *Target;
    
};

class MyGraph 
{
private:
    
    
        
public:
    Node *base;
    Node *curnode;
    Edge *curedge;
    //Node *uppernode;
    
    map<int, Edge*> edges;
    map<int, Edge*>::iterator it;
    pair<map<int, Edge*>::iterator,bool> ret;
    map<int, wxString> nodesel;
    
    int stdtolerant;//standardna tolerancia na klikanie hran
    int numedge;
    int number;
    int stdWidth;//standardna sirka vrchola
    int stdHeight;//standarsna vyska vrchola
    int minWib; //minimalna medzera medzi vrcholmi na sirku
    int minHeb;//minimalna medzera medzi vrcholmi na vysku
    bool insertMode;
    bool editMode;
    bool editEdgeMode;
    //
    wxString strrr;
    //
    
    int push(wxPoint p);
    int push(wxPoint p, int w, int h, Node *curnode1);
    void FindCurrent(wxPoint p);
    Node *FindNode(int id);
    int FindNumberFreeX(int a, int b, int y, int h);
    int FindNumberFreeY(int a, int b, int x, int w);
    void EmBiggerNode(Node *n, Node *current);
    void Shiftx(Node *n, int frx);
    void Shifty(Node *n, int fry);
    void MoveVertex(Node *curnode1, wxPoint p);
    wxPoint ChangeToRelative(Node *curnode1, wxPoint p);
    wxPoint ChangeToAbsolute(Node *currnode, wxPoint p);
    void PaintGraph(wxBufferedPaintDC *dc);
    void PaintFirstSon(Node *current, wxBufferedPaintDC *dc);
    void PrintEdges(wxBufferedPaintDC *dc);
    void MakeEdge(Node *source, Node *target);
    Line *MakeLineEquation(wxPoint s, wxPoint t);
    wxPoint ArrowPosition(float d, float k, float q, wxPoint p, bool toLeft);
    wxPoint Inverse(wxPoint p);
    void UpdateLineEquation(Node *nn);
    Edge *FindEdge(wxPoint p);
    wxPoint DeleteNode(Node *curnode1); 
    void DeleteEdge(Edge *e);
    void DeleteAllEdges(Node *n);
    bool ImportGraph(TiXmlDocument doc, int w, int h);
    map<wxString, int> ParseGraph(TiXmlElement* graphel, map<wxString, int> nodes, map<wxString, wxString> keys, bool viewMode);
    bool ExportGraph( TiXmlDocument doc);
    TiXmlElement *Linknode(Node *fnode, int num,wxString prefix);
    MyGraph();
    ~MyGraph();
    
//    void OnPaint(wxPaintEvent& event);
//    void OnClick(wxMouseEvent& event);
//    void OnEraseBackground(wxEraseEvent& event);
//    void PaintBackground(wxDC& dc);

  //  Node *LeftBrother;
//    Node *RightBrother;
//    Node *FirstSon;
//    Node *LastSon;
    //int x;
//    int y;

};
